/*
Ingegneria Clinica
Fondamenti di Informatica
Prova di Esame del 12 Gennaio 2009
*/

#include<stdio.h>
#include<stdlib.h>

#define MAX_ARTICOLI 100
#define MAX_CLIENTI 100

typedef struct
{
     char nomeAlbergo[100];
     int numeroStanza;
     int prezzo;
     char categoria[100];
     char disponibilita[3];   
} Stanza;

typedef struct
{
     char nome[100];
     char cognome[100];
     char via[100];
     int civico;
     char ultimoAlbergo[100];
     int numeroStanza;
} Cliente;

int CaricaDatiStanze(Stanza *ElencoStanze, char *nomefile)
{
    FILE *fp;
    int counter = 0;
    char parolaDaLeggere[100];
    if((fp = fopen(nomefile,"r")) == NULL)
    {
         return 0;
    }
    while (fscanf(fp, "%s", parolaDaLeggere) != EOF)
    {
         strcpy(ElencoStanze->nomeAlbergo, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         ElencoStanze->numeroStanza = atoi(parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         ElencoStanze->prezzo = atoi(parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoStanze->categoria, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoStanze->disponibilita, parolaDaLeggere);
         ElencoStanze++;
         counter++;       
    }
    fclose(fp);
    return counter;
}

/*Versione alternativa con i puntatori
int CaricaDatiClienti(Cliente *ElencoClienti, char *nomefile)
{
    FILE *fp;
    int counter = 0;
    char parolaDaLeggere[100];
    if((fp = fopen(nomefile,"r")) == NULL)
    {
         return 0;
    }
    while (fscanf(fp, "%s", parolaDaLeggere) != EOF)
    {
         strcpy(ElencoClienti->nome, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoClienti->cognome, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoClienti->via, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         ElencoClienti->civico = atoi(parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         strcpy(ElencoClienti->ultimoAlbergo, parolaDaLeggere);
         fscanf(fp, "%s", parolaDaLeggere);
         ElencoClienti->numeroStanza=atoi(parolaDaLeggere);
         ElencoClienti++;
         counter++;       
    }
    fclose(fp);
    return counter;
}
*/

int CaricaDatiClienti(Cliente ElencoClienti[], char nomefile[50])
{
    FILE *fp;
    int counter = 0;
    
    if((fp = fopen(nomefile,"r")) == NULL)
    {
         return 0;
    }
    
    while (!feof(fp))
    {
    
         fscanf(fp, "%s", ElencoClienti[counter].nome);

         fscanf(fp, "%s", ElencoClienti[counter].cognome);

         fscanf(fp, "%s", ElencoClienti[counter].via);

         fscanf(fp, "%d", &ElencoClienti[counter].civico);

         fscanf(fp, "%s", ElencoClienti[counter].ultimoAlbergo);

         fscanf(fp, "%d", &ElencoClienti[counter].numeroStanza);

         counter++;         
    
    }
    fclose(fp);
    return counter;
}

void DisponibilitaStanze(Stanza *ElencoStanze,
                                    int num_stanze,
                                    char *nomeAlbergo,
                                    char *categoria)
{
    int i;
    printf("\nElenco stanze DISPONIBILI Albergo: %s Categoria: %s\n",
                            nomeAlbergo, categoria);
    printf("==============================================================\n");

    for(i = 0; i < num_stanze; i++, ElencoStanze++)
    {
          if(   (strcmp(ElencoStanze->nomeAlbergo, nomeAlbergo) == 0) &&
                (strcmp(ElencoStanze->categoria, categoria) == 0) &&
                (strcmp(ElencoStanze->disponibilita, "SI") == 0) )            
          {
                printf("%s %d %d %s\n",
                     ElencoStanze->nomeAlbergo,
                     ElencoStanze->numeroStanza,
                     ElencoStanze->prezzo,
                     ElencoStanze->categoria);
          }
                
    }
    printf("\n");
}

void UltimaStanzaVisitata (Cliente ElencoClienti[], Stanza ElencoStanze[], int num_stanze, int num_clienti, char nome[], char cognome[]) 
{
   int i;
   int trovato=0;
   
   char nomeAlbergo[100];
   int nstanza;
   
   for(i = 0; i < num_clienti && !trovato; i++)
    {
          if(   (strcmp(ElencoClienti[i].nome, nome) == 0) &&
                (strcmp(ElencoClienti[i].cognome, cognome) == 0))            
          {
                printf("Cliente: %s %s\n", nome, cognome);
                printf("======================================\n");
                     
                trovato=1;
                
                nstanza=ElencoClienti[i].numeroStanza;
                strcpy(nomeAlbergo, ElencoClienti[i].ultimoAlbergo);
          }
                
    } 
    
    trovato=0;
    
    for(i = 0; i < num_stanze && !trovato; i++)
    {
          if(   (strcmp(ElencoStanze[i].nomeAlbergo, nomeAlbergo) == 0) && ElencoStanze[i].numeroStanza == nstanza)            
          {
                printf("%s\t%d costo %d\t%s\n", nomeAlbergo, nstanza,
                     ElencoStanze[i].prezzo,
                     ElencoStanze[i].categoria);
                     
                trovato=1;               
                
          }
                
    } 
     
   return;
}



int main(){
    Stanza ElencoStanze[MAX_ARTICOLI];
    int totale_stanze =
        CaricaDatiStanze(ElencoStanze, "stanze.txt");
    if(totale_stanze == 0)
    {
        printf("nessuna stanza caricata\n");
        exit(-1);
    }
    else
    {
        printf("\ncaricate %d stanze\n", totale_stanze);
        int i;
        for(i = 0; i < totale_stanze; i++)
        {
                printf("%s %d %d %s %s\n",
                     ElencoStanze[i].nomeAlbergo,
                     ElencoStanze[i].numeroStanza,
                     ElencoStanze[i].prezzo,
                     ElencoStanze[i].categoria,
                     ElencoStanze[i].disponibilita);
        }    
    }
    Cliente ElencoClienti[MAX_CLIENTI];
    int totale_clienti = CaricaDatiClienti(ElencoClienti, "clienti.txt");
    if(totale_clienti == 0)
    {
        printf("nessun cliente caricato\n");
        exit(-1);
    }
    else
    {
        printf("\ncaricati %d clienti\n", totale_clienti);
        int j;
        for(j = 0; j < totale_clienti; j++)
        {
                printf("%s %s %s %d %d\n",
                     ElencoClienti[j].nome,
                     ElencoClienti[j].cognome,
                     ElencoClienti[j].via,
                     ElencoClienti[j].civico,
                     ElencoClienti[j].ultimoAlbergo,
                     ElencoClienti[j].numeroStanza);
        }    
    }
    
    DisponibilitaStanze(ElencoStanze, totale_stanze, "BelVedere", "suite");
    
    UltimaStanzaVisitata (ElencoClienti, ElencoStanze, totale_stanze, totale_clienti, "Benedetto", "Pace") ;
     
     system("PAUSE");
}
